def generate_subsets_alt(sol, a):
    # Базовый вариант
    if len(sol) == len(a):
        # Печать полного решения
        print_subset_binary(sol, a)
    else:
        # Генерация элементов-кандидатов
        for k in range(0, 2):

            # Включить кандидата в частное решение
            sol = sol + [k]

            # Генерация элемента в позиции i+1
            generate_subsets_alt(sol, a)

            # Удалить кандидата из частного решения
            del sol[-1]


def print_subset_binary(sol, elements):
    no_elements = True
    print('{', end='')
    for i in range(0, len(sol)):
        if sol[i] == 1:
            if no_elements:
                print(elements[i], sep='', end='')
                no_elements = False
            else:
                print(', ', elements[i], sep='', end='')
    print('}')


def generate_subsets_alt_wrapper(elements):
    sol = []
    generate_subsets_alt(sol, elements)


generate_subsets_alt_wrapper(['a', 'b', 'c'])
